################## code die gegeven is uit les 3 
import numpy as np
from PIL import Image,ImageDraw


def puntco(ppi,kader,size):
    return [ppi[0]/size[0]*(kader[1][0]-kader[0][0]) + kader[0][0], ppi[1]/size[1]*(kader[1][1]-kader[0][1]) + kader[0][1]]
def pixelco(ppu,kader,size):
    return [size[0]/(kader[1][0]-kader[0][0])*(ppu[0] - kader[0][0]), size[1]/(kader[1][1]-kader[0][1])*(ppu[1]-kader[0][1])]


class aff():
    def __init__(self,A,B):
        self.n= len(B)+1
        self.A = np.array(A)
        self.B = np.array([[x] for x in B])
    def transform(self,lijst):
        return [tuple(np.transpose(self.A.dot(np.transpose(np.array([v]))) + self.B)[0]) for v in lijst]
    def inverse(self):
        return aff(np.linalg.inv(self.A), np.transpose(np.linalg.inv(self.A).dot(-self.B))[0])
    def __mul__(self,other):
        if isinstance(other,aff):
            return aff(self.A.dot(other.A), np.transpose(self.A.dot(other.B)+self.B)[0])
        elif isinstance(other,tuple):
            return self.transform([other])[0]
        else:
            return NotImplemented
        
def rotation3d(p,dr,theta):
    tmp1 = aff(np.identity(3),p)
    tmp2 = aff([[np.cos(theta)+dr[0]*dr[0]*(1-np.cos(theta)),dr[1]*dr[0]*(1-np.cos(theta))-dr[2]*np.sin(theta),dr[2]*dr[0]*(1-np.cos(theta))+dr[1]*np.sin(theta)],
            [dr[0]*dr[1]*(1-np.cos(theta))+dr[2]*np.sin(theta),np.cos(theta)+dr[1]*dr[1]*(1-np.cos(theta)),dr[2]*dr[1]*(1-np.cos(theta))-dr[0]*np.sin(theta)],
            [dr[0]*dr[2]*(1-np.cos(theta))-dr[1]*np.sin(theta),dr[1]*dr[2]*(1-np.cos(theta))+dr[0]*np.sin(theta),np.cos(theta)+dr[2]*dr[2]*(1-np.cos(theta))]], (0,0,0))    
    return tmp1 * tmp2 * tmp1.inverse()


FARAWAY = 1e35
class triangle():
    def __init__(self,p,q,r,kl,texture=None):
        self.p = [p,q,r]
        self.n = np.cross([self.p[1][i]-self.p[0][i] for i in range(3)],[self.p[2][i]-self.p[0][i] for i in range(3)])
        if abs(np.linalg.norm(self.n))>1e-6: 
            self.n = self.n / np.linalg.norm(self.n)   
        else:
            self.n = 0* self.n
        self.color = kl
        self.texture = texture
    def __rmul__(self,trn):
        return triangle(trn*self.p[0],trn*self.p[1],trn*self.p[2],self.color,self.texture)
    def intersect(self,E,D):
        try:
            coefs = np.array(D).dot(np.linalg.inv(np.array([self.p[0], self.p[1], self.p[2]])-np.array([E,E,E])))
            if coefs[0]>0 and coefs[1]>0 and coefs[2]>0:
                if type(self.texture)==type(None):
                    ll = 1/(coefs[0]+coefs[1]+coefs[2])
                else:
                    ll = 1/(coefs[0]+coefs[1]+coefs[2])
                    tco = (int(coefs[1]/(sum(coefs))*self.texture.size[0]), int(coefs[2]/(sum(coefs))*self.texture.size[1]))
                    self.color = np.array(self.texture.getpixel(tco))
                    if self.color[3]==0: ll=FARAWAY
            return ll
        except:
            return FARAWAY
        #######################deze functie is toegevoegd
    def colorlight(self,E,D,dst,L):
        c = abs(self.n.dot(L))
        return (np.uint8(self.color[0]*c),np.uint8(self.color[1]*c),np.uint8(self.color[2]*c),np.uint8(self.color[3])) 


def getpixel(mesh,E,D,L):    ########L toegevoegd
    tr = 0
    dst = FARAWAY
    for i in range(len(mesh)):
        tmp = mesh[i].intersect(E,D)
        if tmp<dst :
            dst = tmp
            tr = i
    if dst< FARAWAY:
        return tuple(mesh[tr].colorlight(E,D,dst,L))  ########L toegevoegd
    else:
        return (0,0,0,0)

octa1 = []    
for i in [1,-1]:
    for j in [1,-1]:
        for k in [1,-1]:
            octa1.append(triangle((i/2,0,0),(0,j/2,0),(0,0,k/2),np.uint8((255,255,0,255))))
R = rotation3d((0,0,0),(1,1,1),np.pi/10)            
octa2 = [ R * T  for T in octa1]

octa3 = []    
for i in [1,-1]:
    for j in [1,-1]:
        for k in [1,-1]:
            octa3.append(triangle((i/2,0,0),(0,j/2,0),(0,0,k/2),np.uint8((128+i*80,128+j*80,128+k*80,255))))
octa3 = [ R * T  for T in octa3]


class camera():
    def __init__(self,E,L,S,X,Y): ########L toegevoegd
        self.E=np.array(E)
        self.L=np.array(L)
        self.S=np.array(S)
        self.X=np.array(X)
        self.Y=np.array(Y)
    def ray(self,u,v): 
        return self.S - self.E + self.X*u + self.Y*v
    def image(self,mesh,kader,size):
        img = Image.new('RGBA', size)
        relevant = [[[] for j in range(size[1])] for i in range(size[0])]
        for t in mesh:
            if isinstance(t, triangle):
                pco = [pixelco(i/i[2],kader,size) for i in (np.array(t.p)-np.array([self.E,self.E,self.E])).dot(np.linalg.inv(np.array([self.X, self.Y, self.S-self.E])))]
                pco = np.transpose(pco)
                #print(pco)
                imin = max(np.floor(min(pco[0]))-1,0)
                imax = min(np.ceil(max(pco[0]))+1,size[0])
                jmin = max(np.floor(min(pco[1]))-1,0)
                jmax = min(np.ceil(max(pco[1]))+1,size[1])
            else:
                imax=size[0]
                imin= 0
                jmax=size[1]
                jmin= 0
            for i in range(int(imin),int(imax)):
                for j in range(int(jmin),int(jmax)):
                    relevant[i][j].append(t)
        for j in range(size[1]):
            for i  in range(size[0]):
                D = self.ray(i/size[0]*(kader[1][0]-kader[0][0])+kader[0][0],j/size[1]*(kader[1][1]-kader[0][1])+kader[0][1])
                img.putpixel((i,j),tuple(getpixel(relevant[i][j],self.E, D,self.L)))
                #if len(relevant[i][j])>2: img.putpixel((i,j),(255,0,0,255)) 
                ########L toegevoegd
        img.show()
    def slowimage(self,mesh,kader,size):
        img = Image.new('RGBA', size)
        for j in range(size[1]):
            for i  in range(size[0]):
                img.putpixel((i,j),tuple(getpixel(mesh,self.E, self.ray(i/size[0]*(kader[1][0]-kader[0][0])+kader[0][0],j/size[1]*(kader[1][1]-kader[0][1])+kader[0][1]),self.L)))    ########L toegevoegd
        img.show()

        
class plane():
    def __init__(self,img,h,kader):
        self.img = img
        self.h = h
        self.kader = ((min(kader[0][0],kader[1][0]),min(kader[0][1],kader[1][1])),(max(kader[0][0],kader[1][0]),max(kader[0][1],kader[1][1])))
    def intersect(self,E,D):
        tmp = FARAWAY
        if D[2]*(self.h-E[2])>0:
            tmp = (self.h-E[2])/D[2]
        return tmp
    def colorlight(self,E,D,dst,L):
        pp = (E[0] + (self.h-E[2])/D[2]*D[0],E[1] + (self.h-E[2])/D[2]*D[1])
        pp = tuple([scale(pp[i],self.kader[0][i],self.kader[1][i])*(self.img.size[i]-2) for i in [0,1]])
        kl = np.array(self.img.getpixel((int(pp[0]),int(pp[1]))))*(1-pp[0]%1)*(1-pp[1]%1)
        kl += np.array(self.img.getpixel((int(pp[0])+1,int(pp[1]))))*(pp[0]%1)*(1-pp[1]%1)
        kl += np.array(self.img.getpixel((int(pp[0]),int(pp[1])+1)))*(1-pp[0]%1)*(pp[1]%1)
        kl += np.array(self.img.getpixel((int(pp[0])+1,int(pp[1])+1)))*(pp[0]%1)*(pp[1]%1)        
        return tuple([int(i) for i in kl])


